#include <S.h>
#include <Rinternals.h>

SEXP convolve3(SEXP a, SEXP b)
{
    int i, j, na, nb, nab;
    SEXP ab;

    na = length(a); nb = length(b); nab = na + nb - 1;
    PROTECT(ab = allocVector(REALSXP, nab)); 
    /* or ab = NEW_NUMERIC(nab) */
    for(i = 0; i < nab; i++) REAL(ab)[i] = 0.0;
    for(i = 0; i < na; i++)
	for(j = 0; j < nb; j++)
	    REAL(ab)[i + j] += REAL(a)[i] * REAL(b)[j];
    UNPROTECT(1);
    return(ab);
}
