#include <Rinternals.h>

SEXP showArgs(SEXP args)
{
  int i = 1, len;
  Rcomplex cpl;
  char *name;
    
  args = CDR(args);
  while(args != R_NilValue) {
    name = CHAR(PRINTNAME(TAG(args)));
    len = length(CAR(args));
    switch(TYPEOF(CAR(args))) {
    case REALSXP:
        printf("[%d] '%s' length %d %f ...\n", i+1, name, 
	       len, REAL(CAR(args))[0]);
	break;
    case LGLSXP:
    case INTSXP:
        printf("[%d] '%s' length %d %d ...\n", i+1, name, 
	       len, INTEGER(CAR(args))[0]);
	break;
    case CPLXSXP:
        cpl = COMPLEX(CAR(args))[0];
        printf("[%d] '%s' length %d %f + %fi ...\n", i+1, 
	       name, len, cpl.r, cpl.i);
        break;
    case STRSXP:
        printf("[%d] '%s' length %d '%s' ...\n", i+1, name,
	       len, CHAR(STRING(CAR(args))[0]));
        break;
    default:
        printf("[%d] '%s' R type\n", i+1, name);
    }
    args = CDR(args);
  }
  return(R_NilValue);
}
