library(MASS)
if(exists("is.R") && is.R()) {
    data(trees)
    names(trees) <- c("diam", "height", "volume")
    data(stormer)
}
tree.lm <- lm(log(volume) ~ log(diam) + log(height), trees)
tree.est <- estimate(tree.lm)
tree.est
Trees <- expand.grid(diam=5*2:4, height=10*6:8)
vol.est <- estimate(tree.est,
                    ~exp(b0 + b1*log(diam) + b2*log(height)), Trees,
                    se.only = T)
m <- rbind(exp(predict(tree.lm, Trees)), vol.est$SE)
dimnames(m) <- list(c("vol", "se"),
                    apply(Trees, 1, function(x) paste(x, collapse=",")))
round(m, 2)

storm.nls <- nls(Time ~ beta*Viscosity/(Wt - theta),
                 stormer, start = c(beta = 29, theta = 2))
estimate(storm.nls)

storm.glm <- glm(Time ~ I(Wt/Viscosity)+I(-1/Viscosity)-1,
                 quasi(link = inverse, variance = constant), stormer,
                 eps = 1.0e-8)
storm.glm.est <- estimate(storm.glm)
estimate(storm.glm.est, list(beta ~ 1/b1, theta ~ b2/b1))
